#include "stdafx.h"
#include "spltest.h"
#include "splasher.h"
#include "MainFrm.h"
#include "spltestDoc.h"
#include "spltestView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CSpltestApp, CWinApp)
	//{{AFX_MSG_MAP(CSpltestApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

CSpltestApp::CSpltestApp()
{
}

CSpltestApp theApp;

BOOL CSpltestApp::InitInstance()
{
#ifdef _AFXDLL
	Enable3dControls();
#else
	Enable3dControlsStatic();
#endif

	LoadStdProfileSettings();


  //ADDITION OF SPLASH SCREEN COMPONENT
  //Bring up the splash screen in a secondary UI thread
  CSplashThread* pSplashThread = (CSplashThread*) AfxBeginThread(RUNTIME_CLASS(CSplashThread), THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
  if (pSplashThread == NULL)
  {
    AfxMessageBox(_T("Failed to create splash screen"), MB_OK | MB_ICONSTOP);
    return FALSE;
  }
  ASSERT(pSplashThread->IsKindOf(RUNTIME_CLASS(CSplashThread)));

  //Tell the splash screen to load the bitmap from a resource called IDB_SPLASH.
  //Alternatively, you could use the line:
  //  pSplashThread->SetBitmapToUse(GetHomeDirectory() + _T("TEST.BMP")); 
  //if you wanted the splasher code to load a bitmap from file at runtime.
  pSplashThread->SetBitmapToUse(IDB_SPLASH);  

  pSplashThread->ResumeThread();  //Resume the thread now that we have set it up 

  Sleep(5000);                    //Simulate some slow loading process. Your code might 
                                  //load up some info from a file or make a network connection etc.

  pSplashThread->HideSplash();    //Bring down the splash screen
  

	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CSpltestDoc),
		RUNTIME_CLASS(CMainFrame),
		RUNTIME_CLASS(CSpltestView));
	AddDocTemplate(pDocTemplate);

	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (!ProcessShellCommand(cmdInfo))
		return FALSE;


  //ADDITION OF SPLASH SCREEN COMPONENT
  //This is required to activate the normal mainframe, If you remove the splash
  //screen, then the main frame window is brought up but will not
  //be at the top of the Z Order.
  m_pMainWnd->SetForegroundWindow();


	return TRUE;
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


void CSpltestApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

CString CSpltestApp::GetHomeDirectory() const
{
  TCHAR sFilename[_MAX_PATH];
  TCHAR sDrive[_MAX_DRIVE];
  TCHAR sDir[_MAX_DIR];
  TCHAR sFname[_MAX_FNAME];
  TCHAR sExt[_MAX_EXT];
  GetModuleFileName(AfxGetInstanceHandle(), sFilename, _MAX_PATH);
  _tsplitpath(sFilename, sDrive, sDir, sFname, sExt);

  CString rVal(CString(sDrive) + CString(sDir));
  int nLen = rVal.GetLength();
  if (rVal.GetAt(nLen-1) != _T('\\'))
    rVal += _T("\\");

  return rVal;
}

